;	DTMF PWM GENERATOR v1.0
;	(c) 2004 Radu Constantinescu
;	constantinescuradu at yahoo.com
;	Free for Noncomercial use.
;
;	
;	DTMF SOFTWARE DECODER v2.0
;	(c) 2003-2004 Radu Constantinescu
;	constantinescuradu at yahoo.com
;	based on a David Hedley idea
;	
;	SERIAL ROUTINES with Buffer
; 	modified by Radu Constantinescu - eliminate calls in order to save stack space
; 	UART routines with TX and RX buffers By Tony Kbek 2000-06-22 free for use	
;
;	PWM SIGNAL GENERATOR
;	timer 2 used to generate interupts at 9765.625hz
;	PWM1 output at 78.12hz
;
;	SOFTWARE DTMF DECODER 
;	modified Goertzel algorithm
;	timer 2 used to generate interupts at 9765.625hz
;	with 1X and 2X frequency bins
;
;	 
;
;
;	FOR 16F88 / 20 Mhz
;	F sample = 5000000/512 hz = 9765. 625 hz
;
;	RB3 OUT pin 9 PWM1 DTMF OUT - connect to a low pass filter
;	RA0 analog IN pin 17  DTMF/FSK INPUT (A/D) - RA0 Signal source must ve impedance lower thah 2K5
;	as per Microchip specifications and must have Vcc/2 bias.;
;
;	RB2 IN pin 8 Serial Rx
;	RB5 OUT pin 11 Serial Tx
;		
;	RB1 OUT pin 7 Interrupt Indicator ( =1 durring interrupt)
;	RB4	OUT	pin 10 FSK DCD - ACTIVE LOW
;	RB0 OUT pin 6 FSK DATA
; 
;
;	started JAN 31 2004
;
;	
;config bits
;2007	2762 
;2008	3ffc
; define treshods for the dtmf decoder
#define treshold1XL .240/4	; for 1X frequencies DTMF detector / 240 samples
#define treshold1XH .240/5	; for 1X frequencies DTMF detector / 240 samples
#define treshold2XL .113/3	; for 2X frequencies DTMF detector / 113 samples
#define treshold2XH .113/3	; for 2X frequencies DTMF detector / 113 samples
; 50 40 2
; 40 40 3 < best OF 126 - GOOD EXCEPT *
; 35 35 3

	RADIX DEC
#include <p16f88.inc>
#include <macro.asm>
; base frequency
XTAL_FREQ	EQU	20000000	; OSC freq in Hz
#include <serial.asm>
#include <tables.asm>



	CBLOCK 0x20
;****************************
; Bank0 Int Save
;****************************
PCLATH_SAVE:	1
STATUS_TEMP:	1
FSR_SAVE:	1

;****************************
; DTMF GENERATOR VARIALBLES
;****************************
PWMVAL:	1	; intermediate PWM Value (another temp register for interrupts can be used)
AccHH:	1	; Accumulator High High Frequency
AccLH:	1	; Accumulator Lo High Fequency
AccHL:	1	; Accumulator High Low Frequency
AccLL:	1	; Accumulator Lo Low Fequency
XAddHH:	1	; Acc Add High High Frequency
XAddLH:	1	; Acc Add Lo High frequency
XAddHL:	1	; Acc Add High Low Frequency
XAddLL:	1	; Acc Add Lo Low frequency
TempH:	1	; ISR Temp PWM value for High Frequency, reused in the DTMF Detector ISR for Temp Lowtemplate
TempL:	1	; ISR Temp PWM value for Low Frequency, reused in the DTMF Detector ISR for Temp Highemplate


; 	Freq	AddH	AddL	Error(%)
; 	1000	26		55		0.001692772
;	697	18		69		-0.01042912
;	770	20		47		-0.007402742
;	852	22		86		0.005680407
;	941	24		171		0.000885164
;	1209	31		177		-0.00569002
;	1336	35		6		0.002852743
;	1477	38		184		0.000209718
;	1633	42		207		0.001117896

;Frequency	1209	1336	1477	1633
;697		1		2		3		A
;770		4		5		6		B
;852		7		8		9		C
;941		*		0		#		D
 
;****************************
; SERIAL ROUTINES VARIABLES
;****************************

	; serial buffer RX and TX  pointers, buffers located in bank1

	RX_Buffer_InPtr:1	; where to put next incomming byte
	RX_Buffer_OutPtr:1	; where to get next ( first ) byte
	RX_Buffer_Count:1	; how many we have in buffer

	TX_Buffer_InPtr:1	; where to put next outgoing byte
	TX_Buffer_OutPtr:1	; whre to get next byte 
	TX_Buffer_Count:1	; how many we have in buffer
	TX_Temp:1		; temporary reg used while sending
	Flags:1			; flags for serial comunincation
	
	EE_Byte:1		; Temp var for EEProm Routines

	Temp:1			; temp byte ONLY to be used locally and no calls !
	FSRSAVE:1
;****************************
; DELAY ROUTINES VARIABLES
;****************************
	TIME0:	1		;DELAY COUNTER LSB
	TIME1:	1		;DELAY COUNTER MSB
;****************************
; DTMF DECODER ROUTINES VARIABLES
;****************************

	A697SIN:1
	A697COS:1	; ACCUMULATOR for 697 Hz sin
	A770SIN:1
	A770COS:1	; ACC
	A852SIN:1
	A852COS:1	; ACC
	A941SIN:1
	A941COS:1	; ACC
	A1209SIN:1
	A1209COS:1	;ACC
	A1336SIN:1
	A1336COS:1	;ACC
	A1447SIN:1
	A1447COS:1	;ACC
	A1633SIN:1
	A1633COS:1	;ACC
; double frequency bins
	A697SIN2:1
	A697COS2:1	; ACCUMULATOR for 697 Hz sin
	A770SIN2:1
	A770COS2:1	; ACC
	A852SIN2:1
	A852COS2:1	; ACC
	A941SIN2:1
	A941COS2:1	; ACC
	A1209SIN2:1
	A1209COS2:1	;ACC
	A1336SIN2:1
	A1336COS2:1	;ACC
	A1447SIN2:1
	A1447COS2:1	;ACC
	A1633SIN2:1
	A1633COS2:1	;ACC

	SAMPLEBIT:1
	TABLECOUNTER:1
	LOWTEMPLATE:1	; USED BY DTMF DETECTOR ISR - temp val for Lowfreq Table Value
	HIGHTEMPLATE:1	; USED BY DTMF DETECTOR ISR - temp val for Highfreq Table Value
	BYTE_DTMF:1
	RESULT1:1	; DECODED DIGIT OR 0
	RESULT:1	; USED BY DTMF DETECTOR ISR - result bits for 1X BINS
	RESULT2X:1	; USED BY DTMF DETECTOR ISR - result bits for 2X BINS
	FSR_SAVE_DTMF:1	; DTMF ISR ROUTINE TEMP Variable
	TEMP_VAL:1		
	TEMP_TIMES:1
	DTMF_RESULT:1	; LAST detected DTMF digit or '-'
	
	LASTBIT:1	; 0 OR 1(FF)
	BITCHANGES:1	; COUNT THE NUMBER OF BIT CHANGES, INCREMENT AT EACH INPUT BIT CHANGE

	ENDC
	
; ************* Bit variable definitions ***************************
	#define _BufferOverrun	Flags,0 ; Serial RX buffer overrun
	#define TIMEOUT		Flags,1 ; timeout flag
	#define DTMF_GEN_ON	Flags,2 ; DTMF GENERATOR ON/OFF
	#define GOT_ONE		Flags,3 ; GOT_ONE is set when at least a char is in the RxBuffer
	#define	DTMF_DONE	Flags,4	; 1 DTMF detector off / 0 - DTMF detector on
	#define	DTMF_DETECTED Flags, 5	; one DTMF digit detected in DTMF_RESULT
	#define	DTMF_RECOVER	Flags,6	; =1 do not send the next digit - just recover (used by the decision alg.)
	#define	Temp_Flag	Flags,7
; *** Bank1 *** 80 bytes, 64 used for Serial Buffers
	CBLOCK	0x0A0
	RX_Buffer:RX_BUFFER_SIZE	; buffer for rx - A0
	TX_Buffer:TX_BUFFER_SIZE	; buffer for tx - C0
	ENDC


;***********************************************
;Shared Ram
;***********************************************

	CBLOCK 0x71	; variables for all the RAM pages, skip 70 for ICD
	W_TEMP:	1	; int W save/shared Ram
	XcomA:	1
	XcomB:	1
	XcomC:	1
	

	temp1:	1	; temp value 1
	ENDC

;***********************************************
;EEprom Variables
;***********************************************
	;ORG	h'2100'		;EEPROM INITIAL VALUES
	;DE	0,0,0,0,0,0,0,0
	;DE	"1234567890"

;****************************


	ORG	0X00
	NOP
	CLRF PCLATH	; Page 0
	CLRF STATUS	; BANK 0
	GOTO	START


INTERRUPT_VECTOR	
	ORG	0X04

;****************************
;
;	CONTEXT SAVE
;
;****************************

C_SAVE	MOVWF	W_TEMP
	SWAPF	STATUS,W
	CLRF	STATUS		;ENSURE BANK0 SAVE
	MOVWF	STATUS_TEMP
	
	BSF	PORTB, 1	; set interrupt indicator
	
	MOVF	PCLATH,W	; SAVE PCLATH
	MOVWF   PCLATH_SAVE

	MOVF	FSR, W
	MOVWF	FSR_SAVE

	BTFSS	PIR1,TMR2IF	; TMR2 Overflow Check
	GOTO	INT_TEST_RX_IRQ	; ; if not timer 2 then goto serial
;**********************
;Timer 2 ISR
;**********************
	BTFSC	DTMF_DONE
	GOTO	T2ISR_1		; Skip A/D input if dtmf detect is off

	CLRF	BYTE_DTMF	; input = 0
	BTFSC	ADRESH,7	; MSB bit of A/D	
	COMF	BYTE_DTMF, F	; input = 1
	
	BSF 	ADCON0, GO	; start a new conversion

;	clrw
;	xorwf	BYTE_DTMF, W
;	btfsC	STATUS, Z
;	BCF		PORTB, 0

;	MOVLW	.255
;	xorwf	BYTE_DTMF, W
;	btfsC	STATUS, Z
;	BSF		PORTB, 0
	
	; COMPARE  input AND lastbit
;	MOVF	LASTBIT, W
;	XORWF	BYTE_DTMF,W
;	BTFSC	STATUS, Z
;	GOTO	LASTBITEND
;	;  IF input <> lastbit
;	INCF	BITCHANGES,	F	; INCREMENT THE NUMBER OF BITCHANGES
;	; LASTBIT = INPUT
;	MOVF	BYTE_DTMF, W
;	MOVWF	LASTBIT
LASTBITEND


	
T2ISR_1
	BCF	PIR1,TMR2IF	; RESET TIMER 2 INT FLAG
	BTFSS	DTMF_GEN_ON	; dtmf generator is on?
	GOTO	DTMF_DETECT	; no, skip to DTMF detect ISR
;**********************
; DTMF GENERATOR ISR
;**********************
; Update High Frequency Generator Accumulator
	MOVF	XAddLH,W	;	Low constant High Frequency
	ADDWF	AccLH,F	;	Add to the low accumulator byte, High Frequency
	MOVF	XAddHH,W	;	High constant High Frequency
	BTFSC	STATUS,C
	ADDLW	1		; 	ADD carry
	ADDWF	AccHH,F	; 	Add to the high accumulator byte, High Frequency
; Update Low Frequency Generator Accumulator
	MOVF	XAddLL,W	;	Low constant Low Frequency
	ADDWF	AccLL,F	;	Add to the low accumulator byte, Low Frequency
	MOVF	XAddHL,W	;	High constant Low Frequency
	BTFSC	STATUS,C
	ADDLW	1		; 	ADD carry
	ADDWF	AccHL,F	; 	Add to the high accumulator byte, Low Frequency

GetSinVal:	; Read the Value from a 128 entries sin table
	;necessary only if table is not alligned
	;MOVLW	LOW GetSinTab
	;ADDWF	ACCH,W	; just set carry
	MOVLW	HIGH GetSinTab
	;BTFSC STATUS,C
	;ADDLW 1
	MOVWF	PCLATH
	MOVF	AccHH,W	; get index
	ANDLW	B'01111111'	; mask upper bit 0-127 only
	CALL	GetSinTab
	; add sign
	BTFSS	AccHH,7	; 2's coplement 256-value if <0
	GOTO	DTMFISR1
	CLRF	TempH
	SUBWF	TempH,W
DTMFISR1:
	MOVWF	TempH	;	Store temp pwm val for high freq
	MOVF	AccHL,W	; get index
	ANDLW	B'01111111'	; mask upper bit 0-127 only
	CALL	GetSinTab
	MOVWF	TempL	;	Store temp pwm val for low freq
	BCF		STATUS, C	; Clear Carry
	RRF		TempL,F	; TempL=TempL/2
	BCF		STATUS, C	; Clear Carry
	RRF		TempL,W	; TempL=TempL/2, result in W
	ADDWF	TempL,W	; TempL = 0.75 TempL --> Low frequency amplitude should be 3dB (0.707) lower than high frequency amplitude, resul in W
	; add sign
	BTFSS	AccHL,7	; 2's coplement 256-value if <0
	GOTO	DTMFISR2
	CLRF	TempL
	SUBWF	TempL,W
DTMFISR2:
	;MOVWF	TempL	;	Store temp pwm val for low freq		

	ADDWF	TempH,W	;	XcomBined PWM Value in W

	ADDLW	128	; 128+w --> value=128+PWM value
	; +50 = 128+50
	; -50 --> hCE+h80=H14e, h4e=78 = 128-50
	; index was 128-255 --> value=128-table read


	CLRF	PCLATH

SetPWMVal:	; set PWM val to W, PWMVAL=CCPR1L<5,0>,CCP1CON<5,4>
	MOVWF	PWMVAL	; temporary
	BCF	CCP1CON,4	; clear CCP1CON<5,4>
	BCF	CCP1CON,5
	RRF	PWMVAL,F	; rotate right with carry
	BTFSC	STATUS,C
	BSF	CCP1CON,4	; store carry in CCP1Con<4>
	RRF	PWMVAL,W
	BTFSC	STATUS,C
	BSF	CCP1CON,5	; store carry in CCP1Con<5>
	ANDLW	B'00111111'
	MOVWF	CCPR1L		; store 6 MSB bits in CCPR1L<5,0>
	; continue to Dtmf Detector ISR

;**********************
; DTMF DETECTOR ISR
;**********************
DTMF_DETECT
	BTFSC	DTMF_DONE
	GOTO	DTMF_ISR_END	; Skip dtmf detect isr if done=1, goto delay ISR

	; input value  in DTMF_BYTE = 00 or FF

;*****************************
;
;Get the expected Lowband Bits
;
;*****************************
	MOVLW	LOW	LOWBAND 
	ADDWF	TABLECOUNTER,W	; add low lowband + tablecounter with carry
	MOVLW	HIGH	LOWBAND	; to pclath
	BTFSC	STATUS,C
	ADDLW	1
	MOVWF	PCLATH		; if the table will be alligned to a 256 boundary this will nor be necessary
	; read 1X template
	MOVF	TABLECOUNTER,W
	CALL	LOWBAND			; read table
	;CLRF	PCLATH
	MOVWF	LOWTEMPLATE
	MOVF	BYTE_DTMF,W
	XORWF	LOWTEMPLATE, F	; APPLY INPUT OVER MASK
	
	; read 2X template - must use TABLECOUNTER X 2 as pointer
	MOVF	TABLECOUNTER,W
	;clear carry
	bcf		STATUS, C		; Carry=0
	rlf		TABLECOUNTER,W	; TABLECOUNTER X 2 > W
	CALL	LOWBAND			; read table
	MOVWF	TempL
	MOVF	BYTE_DTMF,W
	XORWF	TempL, F	; APPLY INPUT OVER MASK

	;CLRF	PCLATH	; clear pclath before any GOTO
;*****************************
;
;Get the expected Highband Bits 
;
;*****************************
	MOVLW	LOW	HIGHBAND
	ADDWF	TABLECOUNTER,W
	MOVLW	HIGH	HIGHBAND
	BTFSC	STATUS,C
	ADDLW	1
	MOVWF	PCLATH
	; read 1X template
	MOVF	TABLECOUNTER,W
	CALL	HIGHBAND
	
	;CLRF	PCLATH
	MOVWF	HIGHTEMPLATE
	MOVF	BYTE_DTMF,W
	XORWF	HIGHTEMPLATE, F	; APPLY INPUT OVER MASK

	; read 2X template - must use TABLECOUNTER X 2 as pointer
	MOVF	TABLECOUNTER,W
	;clear carry
	bcf		STATUS, C		; Carry=0
	rlf		TABLECOUNTER,W	; TABLECOUNTER X 2 > W
	CALL	HIGHBAND		; read table
	MOVWF	TempH
	MOVF	BYTE_DTMF,W
	XORWF	TempH, F	; APPLY 2X frequencies Mask over the 1X frequencies result

	CLRF	PCLATH	; clear pclath before any GOTO.......
;*******************************
;
;	LOWTEMPLATE AND HIGHTEMPLATE 
;	CONTAIN THE EXPECTED VALUES
;	FOR THE INCOMING BIT
;
;*******************************


; do it for the 1Xfreq bins
	MOVLW	LOW A697SIN
	MOVWF	FSR		;ACCUMULATOR ADDR in pointer FSR
	MOVLW	8
	MOVWF	SAMPLEBIT	; samplebit is the number of the bit being tested
COMPAREBITL
	RLF 	LOWTEMPLATE,F
	BTFSS	STATUS,C	
	GOTO	MATCHL
	DECF	INDF,F	; decrement accumulator 
	GOTO	CONTINL
MATCHL	
	INCF	INDF,F	
CONTINL
	INCF	FSR,F	; increment pointer - next accumulator
	DECFSZ	SAMPLEBIT,F	; next bit
	GOTO	COMPAREBITL	;FINISH THE BYTE


;	MOVF	TABLECOUNTER,W
;	SUBLW	.66-1		; 0-65=66 SAMPLES This is the number of samples to test against (max 127)
					; this will go from 0 to 125 and stop at 126, a total of 126 samples
					;treshold-w--> W, carry=0 on borrow,
					; W=31 carry=0, W=30 carry=1, W=29 carry=1!
					; therefore C is 0  for W > treshold
	BTFSS	STATUS,C
	GOTO	SKIPHI1X


	MOVLW	LOW A1209SIN
	MOVWF	FSR		;ACCUMULATOR ADDR
	MOVLW	8
	MOVWF	SAMPLEBIT
COMPAREBITH
	RLF 	HIGHTEMPLATE,F
	BTFSS	STATUS,C	
	GOTO	MATCHH
	DECF	INDF,F
	GOTO	CONTINH
MATCHH	
	INCF	INDF,F	
CONTINH
	INCF	FSR,F
	DECFSZ	SAMPLEBIT,F
	GOTO	COMPAREBITH	;FINISH THE BYTE

SKIPHI1X
; do it again for the 2Xfreq bins
	; SKIP 2X IF TABLECOUNTER>113
	MOVF	TABLECOUNTER,W
	SUBLW	.113-1		;This is the number of samples to test against (max 127)
					; this will go from 0 to 125 and stop at 126, a total of 126 samples
					;treshold-w--> W, carry=0 on borrow,
					; W=31 carry=0, W=30 carry=1, W=29 carry=1!
					; therefore C is 0  for W > treshold
	BTFSS	STATUS,C
	GOTO	SKIPHI2X


	MOVLW	LOW A697SIN2
	MOVWF	FSR		;ACCUMULATOR ADDR in pointer FSR
	MOVLW	8
	MOVWF	SAMPLEBIT	; samplebit is the number of the bit being tested
COMPAREBITL2
	RLF 	TempL,F
	BTFSS	STATUS,C	
	GOTO	MATCHL2
	DECF	INDF,F	; decrement accumulator 
	GOTO	CONTINL2
MATCHL2	
	INCF	INDF,F	
CONTINL2
	INCF	FSR,F	; increment pointer - next accumulator
	DECFSZ	SAMPLEBIT,F	; next bit
	GOTO	COMPAREBITL2	;FINISH THE BYTE

;	MOVF	TABLECOUNTER,W
;	SUBLW	.66-1		;This is the number of samples to test against (max 127)
					; this will go from 0 to 125 and stop at 126, a total of 126 samples
					;treshold-w--> W, carry=0 on borrow,
					; W=31 carry=0, W=30 carry=1, W=29 carry=1!
					; therefore C is 0  for W > treshold
;	BTFSS	STATUS,C
;	GOTO	SKIPHI2X



	MOVLW	LOW A1209SIN2
	MOVWF	FSR		;ACCUMULATOR ADDR
	MOVLW	8
	MOVWF	SAMPLEBIT
COMPAREBITH2
	RLF 	TempH,F
	BTFSS	STATUS,C	
	GOTO	MATCHH2
	DECF	INDF,F
	GOTO	CONTINH2
MATCHH2	
	INCF	INDF,F	
CONTINH2
	INCF	FSR,F
	DECFSZ	SAMPLEBIT,F
	GOTO	COMPAREBITH2	;FINISH THE BYTE

SKIPHI2X

;********************************
;
; Increment Tablecounter 0..255
;
;********************************
	
	INCF	TABLECOUNTER,F
	MOVF	TABLECOUNTER,W
	XORLW	.240		;This is the number of samples to test against (max 127)
					; this will go from 0 to 125 and stop at 126, a total of 126 samples
	BTFSS	STATUS,Z
	GOTO	DTMF_ISR_END
	BSF		DTMF_DONE


DTMF_ISR_END

;**********************
; Delay ISR
;**********************
; TIME1:TIME0 counter will be decremented each Timer2 Tick,
; TIMEOUT flag will be set when counter reaches zero.
DELAY_ISR
	BTFSC	TIMEOUT		; CHECK IF NOT TIMEOUT
	GOTO DELAY_ISR_END
	; DECREMENT TIMEOUT COUNTER
	DECF	TIME0, F
	BTFSS	STATUS, Z
	GOTO	DELAY_ISR_END		; TIME0<>0
	DECF	TIME1, F
	BTFSS	STATUS, Z
	GOTO 	DELAY_ISR_END		; TIME1<>0
	BSF	TIMEOUT		; SET TIMEOUT=TRUE
DELAY_ISR_END
	; continue to Serial ISR	


	goto INT_EXIT	; skip serial


;**********************
; Serial ISR
;**********************
INT_TEST_RX_IRQ
	BTFSS	PIR1,RCIF	; test if serial recive irq
	GOTO	INT_TEST_TX_IRQ ; nope check next
; ***********************************************************************
;  RX_INT_HANDLER - handles the received commands on serial com 
RX_INT_HANDLER
	BTFSS	RCSTA,OERR	; test for overrun error
	GOTO	RX_CHECK_FRAMING
	; when overrun, uart will stop receving the continous 
	; recevive bit must then be reset
	BCF	RCSTA,CREN	; clear continous receve bit
	BSF	RCSTA,CREN	; and set it again
RX_CHECK_FRAMING
	BTFSS	RCSTA,FERR	; check from framing errors
	GOTO	RX_CHECK_BUFFER 
	; framing error do not store this byte
	; read rx reg and discard byte
	GOTO	RX_DISCARD_BYTE 
RX_CHECK_BUFFER	
	MOVF	RX_Buffer_Count,W	; test for space
	XORLW	RX_BUFFER_SIZE
	BTFSC	STATUS,Z
	GOTO	RX_BUFFER_FULL
	; Place the new char in the RxBuffer
	MOVF	RX_Buffer_InPtr,W	; get adress for indirect dressing
	MOVWF	FSR		; setup fsr
	MOVF	RCREG,W		; get received byte
	MOVWF	INDF		; and store it in buffer
	INCF	RX_Buffer_Count,F ; inc buffer counter
	; update pointers
	INC_BUFFER	RX_Buffer_InPtr,RX_Buffer,RX_BUFFER_SIZE
	BSF	GOT_ONE	; set flag 
	GOTO	INT_RX_END
RX_BUFFER_FULL
	; no room for more bytes, set overrun flag
	BSF	_BufferOverrun
	; and clear the last byte ( no room to store it ! )
RX_DISCARD_BYTE
	; optional an error flag could be set to indicate comm error.
	MOVF	RCREG,W		; read byte and discard
; END RX INT HANDLER
INT_RX_END
	BCF	PIR1,RCIF	; clear rx int flag
INT_TEST_TX_IRQ
	BTFSS	PIR1,TXIF	; test if serial transmit irq
	GOTO	INT_TEST_NXT
; ***********************************************************************
;  TX_INT_HANDLER - handles the tramission of bytes on serial com 
;
TX_INT_HANDLER
	MOVF	TX_Buffer_Count,W ; get number of bytes
	BTFSC	STATUS,Z	; buffer empty ?
	GOTO	TX_BUFFER_EMPTY
	
	MOVF	TX_Buffer_OutPtr,W ; get adress for indirect adressing
	MOVWF	FSR		; setup fsr
	MOVF	INDF,W		; get byte
	MOVWF	TXREG		; and put it in tx reg
	DECF	TX_Buffer_Count,F	; decrement buffer counter
	
	; update pointers
	INC_BUFFER	TX_Buffer_OutPtr,TX_Buffer,TX_BUFFER_SIZE
	GOTO	INT_TX_END
TX_BUFFER_EMPTY
	; no more bytes to send disable TX irq
	; code is to avoid bank switching ( using FSR )
	MOVLW	PIE1	; get adress for tx irq enable
	MOVWF	FSR	; setup fsr
	BCF	INDF,TXIE ; and disable tx irq
INT_TX_END
	BCF	PIR1,TXIF	; clear tx int flag
INT_TEST_NXT
	; test whatever left :-)


;**********************
; Context Restore
;**********************
INT_EXIT

	CLRF	STATUS		;ENSURE BANK0 RESTORE
	MOVF	FSR_SAVE,W
	MOVWF	FSR

	MOVF	PCLATH_SAVE,W
	MOVWF	PCLATH		; RESTORE PCLATH

	BCF	PORTB, 1	; reset interrupt indicator

	SWAPF	STATUS_TEMP,W
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W

	RETFIE

;**********************************************************
; Main Program
;**********************************************************



START

INIT	; INIT ROUTINE	
;***************	
; setup delay
;***************
	BCF		TIMEOUT		; KEEP DELAY COUNTER STOPPED
	CLRF	TIME0		; INIT DELAY COUNTER
	CLRF	TIME1
			
;***************	
; setup uart
;***************
	CALL	INIT_UART
	; initialize buffers/pointers	
	CALL	INIT_BUFFERS

;***************	
; setup A/D
;***************
	Bank1
	CLRF	ANSEL		; configure Port A as digital I/O
	BSF	ANSEL,0		; RA0 = analog input
	bsf	TRISA,0		; PORTA0 = input, AN0
	movlw	B'01000000'	; ADFM=0 left justified, ADCS2=1 divide clock by 2,VCFG=00 - VDD VSS reference, XXXX  
	movwf	ADCON1
	Bank0
	movlw	B'10000001'	; ADCS=10=fosc/64(ADCS2=1), CHS=000=RA0, GO=0, X, ADON=1 A/D ON
	movwf	ADCON0

;***************	
; setup DTMF generator
;***************
	BCF DTMF_GEN_ON		; stop dtmf generator

;***************	
; setup DTMF DETECTOR
;***************
	BSF	DTMF_DONE	; STOP DTMF detector
	movlw	'-'
	movwf	TEMP_VAL
	movlw	1
	movwf	TEMP_TIMES
	bcf		DTMF_RECOVER

;*************************
; setup timer2 and PWM and PORTB
;*************************
	CLRF	AccLH
	CLRF	AccHH	; CLEAR High Freq Generator accumulator
	CLRF	AccLL
	CLRF	AccHL	; CLEAR Low Freq Generator accumulator

	BANKSEL PR2	;(bank 1)
	MOVLW	B'00111111'
	MOVWF	PR2	; 78.12Khz PWM with 20Mhz oscillator

	BANKSEL	CCPR1L	;(bank 0)
	MOvLw	B'00100000'
	MOVLW	CCPR1L	; initial PWM value = 128
	BCF CCP1CON,5
	BCF CCP1CON,4
	
	clrf PORTB		; CLEAR PORTB
	; 1=in, 0=out
	movlw	B'11000100'	;port B 7,6 in, 5TxOUT,4 out,  3  OUT,2RxIN, 1out, 0 out
	BANKSEL TRISB	;(bank 1)
	movwf	TRISB

	BANKSEL T2CON	;(bank 0)	
	MOVLW	B'00111000'	; set Timer2 prescaler 1/1, post scaler 1/8
	MOVWF	T2CON

	;BANKSEL CCP1CON	;(bank 0)
	; configure CCP1CON for PWM
	MOVLW	B'00001111'
	IORWF	CCP1CON,F	; set last four bits

	; reset TMR2IF, enable interrupts
	;BANKSEL PIR1	;(bank 0)
	BCF PIR1, TMR2IF
	BANKSEL	PIE1	;(bank 1)	
	BSF	PIE1, TMR2IE
	BANKSEL INTCON	;(bank 0)

; Start the interrupts
	BSF	INTCON,GIE	; global int
	BSF	INTCON,PEIE	; Peripherals int
	
	BSF	T2CON,TMR2ON	; start Timer2, bank0



;*********************************
; MAIN LOOP	
;*********************************
MAIN:


	; send a wellcome string to the serial port
	movlw	LOW linie1                          
	movwf	XcomA                          
	movlw	HIGH linie1                          
	movwf	XcomB                         
	call	ser_rom  ;send str to serial

	MOVLW	"+"
	Call	DTMF_digit ; 1000hz bip

	movlw	LOW linie2                          
	movwf	XcomC                          
	movlw	HIGH linie2                          
	movwf	XcomB                         
	call	DTMF_rom  ;send string linie2 to DTMF



ECHO_SERIAL
	; echo chars received to the serial port
	CALL RX_GET_BUFFER
	BTFSC	STATUS, Z	; or test for zero on return
	GOTO	ECHO_1
	movwf	temp1
	CALL TX_ADD_BUFFER	; SEND CHAR TO SERIAL

	movf	temp1,W		; send char to dtmf generator
	CALL 	DTMF_digit

ECHO_1
	CALL	DETECT_DTMF	; START DTMF DETECTOR
	btfss	DTMF_DETECTED
	goto nonewdigit

	
; new digit detected

		; 5 sec timer
		;DISABLE_IRQ
		MOVLW	.188
		MOVWF	TIME0
		MOVLW	.190
		MOVWF	TIME1
		BCF	TIMEOUT	; start 5 sec delay
		;ENABLE_IRQ
	bsf	Temp_Flag

	; print last digit
	movf	DTMF_RESULT, W
	call	TX_ADD_BUFFER

	goto ECHO_SERIAL


nonewdigit	; no new dtmf digit detected
	;check timeout
	
	btfss	Temp_Flag
	GOTO DTMF_digit_timeout	; wait for Temp_Flag=1
	BTFSS	TIMEOUT
	GOTO DTMF_digit_timeout	; wait for TIMEOUT=1
	; print CRLF
	bcf	Temp_Flag
	movlw	0x0d
	call	TX_ADD_BUFFER
	movlw	0x0a
	call	TX_ADD_BUFFER	
DTMF_digit_timeout
	goto ECHO_SERIAL	; no new dtmf digit detected


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;; Send W hex to serial port + 1 space, uses XcomB, XcomC
PRINTWHEX
	; high nibble, low nibble, space
	MOVWF	XcomB	; save w

	swapf	XcomB, W
	ANDLW	0x0F
	movwf	XcomC
	sublw	9		; test if char = ABCDEF
	movf	XcomC, W
	btfss	STATUS, C	; skip if 0-9
	addlw	.7 ;('A'-'0')-10
	addlw	'0'
	call	TX_ADD_BUFFER ; print high nibble

	movf	XcomB,W
	ANDLW	0x0F
	movwf	XcomC
	sublw	9		; test if char = ABCDEF
	movf	XcomC, W
	btfss	STATUS, C	; skip if 0-9
	addlw	.7	;('A'-'0')-10
	addlw	'0'
	call	TX_ADD_BUFFER ; print low nibble

	movlw	' '
	call	TX_ADD_BUFFER ; print space
	Return			
;************************************************************************
;SUBROUTINES
;************************************************************************

;************************************************************************

; TO START DTMF DETECTOR - CALL DETECT_DTMF - this will return in ~130 timer cycles
; if DTMF_DETECTED=1 on return one NEW DTMF digit was detected in DTMF_RESULT or '-' for pause
;************************************************************************
;START DTMF DECODER
DETECT_DTMF
	;BSF	DTMF_DONE		; STOP DTMF INT ROUTINE

; clear the dtmf detector values
	MOVF	FSR,W
	MOVWF	FSR_SAVE_DTMF		; SAVE FSR
	MOVLW	(Low A697SIN)-1		; start -1
	MOVWF	FSR
TEMPXX1
	INCF	FSR,F
	CLRF	INDF
	MOVF	FSR,W
	XORLW	LOW A1633COS2		; CLEAR RAM FROM A697SIN-A1633COS2!!!
	BTFSS	STATUS,Z
	GOTO	TEMPXX1
		; table read pointer
	CLRF	TABLECOUNTER
	CLRF	RESULT1		; CLEAR RESULT DIGIT
	MOVF	FSR_SAVE_DTMF, W
	MOVWF	FSR		; RESTORE FSR
	;BCF		DTMF_RECOVER	;
	
	CLRF	BITCHANGES	; CLEAR THE COUNTER
	BCF		DTMF_DONE		; CLEAR DONE, START DTMF ISR ROUTINE
	
DETECT1
	;wait for the ISR part to end
	btfss 	DTMF_DONE
	goto	DETECT1
	;got one dtmf digit or '-'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DTMF DECISION ALGORITHM
; compute absolute value  acc = ABS(acc)
	
; FIRST LOOK AT THE BITCHANGES COUNTER > 10
;	MOVF	BITCHANGES,W
;	SUBLW	5	; treshold-w--> W, carry=0 on borrow,
						; W=31 carry=0, W=30 carry=1, W=29 carry=1!
						; therefore the bit is 0 in RESULT for W > treshold
;	BTFSS	STATUS, C
;	GOTO	STARTTEST
	; GOT A QUAIET FRAME - JUST SKIP THE REST
;	MOVLW	'Q'
;	GOTO	SENDIT

STARTTEST
	MOVLW	LOW A697SIN	
	MOVWF	FSR
TESTFORNEG
	BTFSC	INDF,7
	GOTO	NEG
	GOTO	NEXT
NEG
;	SUBTRACT F FROM 0

	MOVF	INDF,W
	SUBLW	0
	MOVWF	INDF
NEXT
	INCF	FSR,F
	MOVF	FSR,W
	XORLW	LOW A1633COS2+1	; for 1X and 2X bins the end is A1633COS2
	BTFSS	STATUS,Z
	GOTO	TESTFORNEG

; add acumulator results for sin and cos,  results in cos , sin=0

	MOVLW	LOW A697SIN	
	MOVWF	FSR
MORERESULTS
	MOVF	INDF,W
	CLRF	INDF
	INCF	FSR,F
	ADDWF	INDF,F
	MOVF	FSR,W
	INCF	FSR,F
	XORLW	LOW A1633COS2 ; for 1X and 2X bins the end is A1633COS2
	BTFSS	STATUS,Z
	GOTO	MORERESULTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; compare acc with treshold1X
; for 1X bins

	MOVLW	LOW A697COS	; first result
	MOVWF	FSR
TEMPX1L
	MOVF	INDF,W
	SUBLW	treshold1XL	; treshold-w--> W, carry=0 on borrow,
						; W=31 carry=0, W=30 carry=1, W=29 carry=1!
						; therefore the bit is 0 in RESULT for W > treshold
	RRF		RESULT,F
	INCF	FSR,F
	INCF	FSR,F
	MOVF	FSR,W
	XORLW	LOW A941COS+2
	BTFSS	STATUS,Z
	GOTO 	TEMPX1L		
	
	MOVLW	LOW A1209COS	; first result
	MOVWF	FSR
TEMPX1H
	MOVF	INDF,W
	SUBLW	treshold1XH	; treshold-w--> W, carry=0 on borrow,
						; W=31 carry=0, W=30 carry=1, W=29 carry=1!
						; therefore the bit is 0 in RESULT for W > treshold
	RRF		RESULT,F
	INCF	FSR,F
	INCF	FSR,F
	MOVF	FSR,W
	XORLW	LOW A1633COS+2
	BTFSS	STATUS,Z
	GOTO 	TEMPX1H		

	COMF	RESULT,F	; complement result>> bit is set if A...COS > TRESHOLD

; RESULT bits are   1633/1477/1336/1209/941/852/770/697 FOR VALUE>Treshold


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; compare acc with treshold2X
; for 2X bins

	MOVLW	LOW A697COS2	; first result
	MOVWF	FSR
TEMPX2L
	MOVF	INDF,W
	SUBLW	treshold2XL	; treshold-w--> W, carry=0 on borrow,
						; W=31 carry=0, W=30 carry=1, W=29 carry=1!
						; therefore the bit is 0 in RESULT for W > treshold
	RRF		RESULT2X,F
	INCF	FSR,F
	INCF	FSR,F
	MOVF	FSR,W
	XORLW	LOW A941COS2+2
	BTFSS	STATUS,Z
	GOTO 	TEMPX2L


	MOVLW	LOW A1209COS2	; first result
	MOVWF	FSR
TEMPX2H
	MOVF	INDF,W
	SUBLW	treshold2XH	; treshold-w--> W, carry=0 on borrow,
						; W=31 carry=0, W=30 carry=1, W=29 carry=1!
						; therefore the bit is 0 in RESULT for W > treshold
	RRF		RESULT2X,F
	INCF	FSR,F
	INCF	FSR,F
	MOVF	FSR,W
	XORLW	LOW A1633COS2+2
	BTFSS	STATUS,Z
	GOTO 	TEMPX2H
		
	;COMF	RESULT2X,F	; complement result>> bit is set if A...COS > TRESHOLD

	movf	RESULT2X, W	; 2X frequencies mask is 0 for 2X freq bin > treshold
	andwf	RESULT, F	; apply 2X frequencies mask over 1X RESULT

; RESULT2 bits are for 2X frequencies  1633/1477/1336/1209/941/852/770/697 FOR VALUE>Treshold

; 	translate to ASCII
;**********************************************
; GOT ONE CHARACTER, CONVERT IT TO ASCII....
;**********************************************
	MOVF	RESULT,W	
	XORLW	B'00010001'
	BTFSC	STATUS,Z
	GOTO	GOTCHA1
	MOVF	RESULT,W
	XORLW	D'33'
	BTFSC	STATUS,Z
	GOTO	GOTCHA2
	MOVF	RESULT,W
	XORLW	D'65'
	BTFSC	STATUS,Z
	GOTO	GOTCHA3
	MOVF	RESULT,W
	XORLW	D'18'
	BTFSC	STATUS,Z
	GOTO	GOTCHA4
	MOVF	RESULT,W
	XORLW	D'34'
	BTFSC	STATUS,Z
	GOTO	GOTCHA5
	MOVF	RESULT,W
	XORLW	D'66'
	BTFSC	STATUS,Z
	GOTO	GOTCHA6
	MOVF	RESULT,W
	XORLW	D'20'
	BTFSC	STATUS,Z
	GOTO	GOTCHA7
	MOVF	RESULT,W
	XORLW	D'36'
	BTFSC	STATUS,Z
	GOTO	GOTCHA8
	MOVF	RESULT,W
	XORLW	D'68'
	BTFSC	STATUS,Z
	GOTO	GOTCHA9
	MOVF	RESULT,W
	XORLW	D'40'
	BTFSC	STATUS,Z
	GOTO	GOTCHA0
	MOVF	RESULT,W
	XORLW	D'72'
	BTFSC	STATUS,Z
	GOTO	GOTCHAPOUND
	MOVF	RESULT,W
	XORLW	D'24'
	BTFSC	STATUS,Z
	GOTO	GOTCHASTAR
	MOVF	RESULT,W	
	XORLW	B'10000001'
	BTFSC	STATUS,Z
	GOTO	GOTCHAA
	MOVF	RESULT,W	
	XORLW	B'10000010'
	BTFSC	STATUS,Z
	GOTO	GOTCHAB
	MOVF	RESULT,W	
	XORLW	B'10000100'
	BTFSC	STATUS,Z
	GOTO	GOTCHAC
	MOVF	RESULT,W	
	XORLW	B'10001000'
	BTFSC	STATUS,Z
	GOTO	GOTCHAD
; GOT ONLY TRASH...
	MOVLW	'-'
	GOTO	SENDIT
; CONVERT ASCII	
	
GOTCHAPOUND
	MOVLW	H'23'
	GOTO	SENDIT
GOTCHASTAR
	MOVLW	H'2A'
	GOTO	SENDIT
GOTCHA1
	MOVLW	H'31'
	GOTO	SENDIT
GOTCHA2
	MOVLW	H'32'
	GOTO	SENDIT
GOTCHA3
	MOVLW	H'33'
	GOTO	SENDIT
GOTCHA4
	MOVLW	H'34'
	GOTO	SENDIT
GOTCHA5
	MOVLW	H'35'
	GOTO	SENDIT
GOTCHA6
	MOVLW	H'36'
	GOTO	SENDIT
GOTCHA7
	MOVLW	H'37'
	GOTO	SENDIT
GOTCHA8
	MOVLW	H'38'
	GOTO	SENDIT
GOTCHA9
	MOVLW	H'39'
	GOTO	SENDIT
GOTCHA0
	MOVLW	H'30'
	GOTO	SENDIT
GOTCHAA
	MOVLW	'A'
	GOTO	SENDIT
GOTCHAB
	MOVLW	'B'
	GOTO	SENDIT
GOTCHAC
	MOVLW	'C'
	GOTO	SENDIT
GOTCHAD
	MOVLW	'D'
	GOTO	SENDIT

SENDIT
	
	MOVWF	RESULT1		; PLACE RECEIVED CHAR IN RESULT1



; print results
;  results in cos , sin=0
	goto newline

	MOVLW	LOW A697COS2	
	MOVWF	FSR
PrintRESULTS
	; Save FSR
	MOVF	FSR, W
	MOVWF	XcomA

	MOVF	INDF,W
	Call 	PRINTWHEX
	
	;restore FSR
	MOVF	XcomA, W
	MOVWF	FSR

	INCF	FSR,F
	INCF	FSR,F
	movf	FSR, W
	XORLW	LOW A1633COS2+2
	BTFSS	STATUS,Z
	GOTO	PrintRESULTS
;newline
	movf	RESULT, W
	call	PRINTWHEX

	movf	RESULT2X, W
	call	PRINTWHEX

	movf	RESULT1, W
	call	TX_ADD_BUFFER

	movlw	0x0d
	call	TX_ADD_BUFFER
	movlw	0x0a
	call	TX_ADD_BUFFER
	
	; wait to transmit all chars
WAIT_TX_BUFFER_EMPTY
	MOVF	TX_Buffer_Count,W ; get number of bytes
	BTFSC	STATUS,Z	; buffer empty ?
	GOTO	WAIT_TX_BUFFER_EMPTY
	
newline

;	movf	RESULT1, W
;	call	TX_ADD_BUFFER
;newline


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DECISION ALGORITHM : A VALUE MUST BE DETECTED AT LEAST 2 TIMES 
; BEFORE IS CONSIDERED VALID
; a missing value is accepted if it was detected at lest 2 times before
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	MOVF	RESULT1, W	; use RESULT1 ASCII result
	XORWF	TEMP_VAL,W	; COMPARE RESULT WITH TEMP_VAL
	BTFSC	STATUS, Z
	GOTO 	DECI1		; ==
	
	; RESULT1<>TEMP_VAL

	decf	TEMP_TIMES, F
	btfss	STATUS, Z
	goto	keepvalue	;<>0
	; reset value
	goto resetvalue		
keepvalue	; keep old RESULT1 value, but temp_times=1 - this will allow 1 missing value 
	; reset temp times to 1
	movlw	1
	movwf	TEMP_TIMES
	bsf		DTMF_RECOVER	; signal recover
	; exception when temp_val='-' ==> reset to RESULT1
	movlw	'-'
	xorwf	TEMP_VAL, W	; compare '-' with result1
	BTFSS	STATUS, Z
	GOTO 	keepvalue1	; ==0
	; reset value
resetvalue
	movlw	1
	movwf	TEMP_TIMES
	movf	RESULT1, W
	movwf	TEMP_VAL
	bcf		DTMF_RECOVER	;	no recover	
keepvalue1
	; no new digit detected
	bcf		DTMF_DETECTED
	RETURN


; RESULT1==TEMP_VAL
DECI1	
	INCF 	TEMP_TIMES, F	; INC TEMP_TIMES
	BTFSC	STATUS,Z
	DECF	TEMP_TIMES, F	; if temp_times=0 decrement to 255
	; check if TEMP_VAL='-'
	movlw	'-'
	xorwf	RESULT1, W	; compare '-' with result1 - if so temp_times=1 and return
	BTFSS	STATUS, Z
	GOTO 	DECI3	; <>0
	movlw	1
	movwf	TEMP_TIMES
	GOTO	keepvalue1
	
DECI3	
	
	MOVLW	.2		; NUMBER OF TIMES DETECTED BEFORE DECIDE FOR A DIGIT!

	XORWF	TEMP_TIMES,W
	BTFSS	STATUS,Z
	GOTO	keepvalue1		; <> no new digit
; GOT ONE VALUE MORE TIMES !!!!!!!!!!!
	BTFSS	DTMF_RECOVER	; test for recover
	GOTO	DECI2			; no recover
	bcf		DTMF_RECOVER	; reset recover bit and return with no new digit
	GOTO	keepvalue1		;  no new digit
DECI2				; exit with new digit
	; return result
	movf	RESULT1, W
	movwf	DTMF_RESULT
	bsf		DTMF_DETECTED
	RETURN





;************************************************************************
; send digit in W to DTMF GENERATOR 0-9, ",", #, *, A, B, C, D, +=1000hz, use XcomA
;************************************************************************
DTMF_digit:
		movwf	XcomA
		;W = value 
		;addlw 255 - Hi
		;addlw (Hi - Lo) + 1
		;Carry is set if W is in range Lo - Hi 
		addlw	255-"9"
		addlw	("9"-"0")+1
		btfss	STATUS,C	; bnc getvalues
		goto	DTMF_digit1		
		; it is a digit
		movf	XcomA,W	; w=digit
		movlw	0x30
		subwf	XcomA,W	; w-f=w, 0-9 index in the table
		; multiply index by 4
		movwf	XcomA
		bcf		STATUS,C
		rlf		XcomA,F
		bcf		STATUS,C
		rlf		XcomA,W
		goto	getvalues

DTMF_digit1	; test A-D
		movf	XcomA,W
		addlw	255-"D"
		addlw	("D"-"A")+1
		btfss	STATUS,C	; bnc getvalues
		goto	DTMF_digit2
		; it is A-D
		movf	XcomA,W	; w=digit
		movlw	0x41
		subwf	XcomA,W	; w-f=w, A-D index in the table
		; multiply index by 4
		movwf	XcomA
		bcf		STATUS,C
		rlf		XcomA,F
		bcf		STATUS,C
		rlf		XcomA,W
		addlw	12*4	; A  index = 12
		goto	getvalues

DTMF_digit2
		movf	XcomA,W	; w=digit		
		SUBLW	","	; it is a comma?
		BTFSC	STATUS,Z
		GOTO comma

		movf	XcomA,W
		SUBLW	"*"	; it is a *?
		movlw	10*4
		BTFSC	STATUS,Z
		GOTO getvalues
		
		movf	XcomA,W
		SUBLW	"#"	; it is a #?
		movlw	11*4
		BTFSC	STATUS,Z
		GOTO getvalues

		movf	XcomA,W
		SUBLW	"+"	; it is a #?
		movlw	16*4
		BTFSC	STATUS,Z
		GOTO getvalues
		; it is something else...skip it
		RETURN
		
getvalues:
		movwf	XcomA	; store index
		MOVLW	HIGH DTMF_GEN_TAB
		MOVWF	PCLATH
		MOVF	XcomA,W	; get index
		CALL	DTMF_GEN_TAB
		MOVWF	XAddHL	; lo freq hi
		INCF	XcomA,F	; increment index
		MOVF	XcomA,W	; get index
		CALL	DTMF_GEN_TAB		
		MOVWF	XAddLL	; lo freq lo		
		INCF	XcomA,F	; increment index
		MOVF	XcomA,W	; get index
		CALL	DTMF_GEN_TAB		
		MOVWF	XAddHH	; Hi freq hi
		INCF	XcomA,F	; increment index
		MOVF	XcomA,W	; get index
		CALL	DTMF_GEN_TAB		
		MOVWF	XAddLH	; Hi freq lo		

		
		; set 200 ms delay
		;BSF TIMEOUT	; stop delay routine
		MOVLW	161
		MOVWF	TIME0
		MOVLW	7
		MOVWF	TIME1
; start DTMF Generator and delay routine

		;DISABLE_IRQ
		BSF DTMF_GEN_ON
		BCF	TIMEOUT	; start 200ms delay
		;ENABLE_IRQ
DTMF_digit3:
		BTFSS	TIMEOUT
		GOTO DTMF_digit3	; wait for TIMEOUT=1

		; stop DTMF
		DISABLE_IRQ
		BCF DTMF_GEN_ON
	; continue from previous point, do not clear acc and PWM value
		MOvLw	B'00100000'
		MOVLW	CCPR1L	; initial PWM value = 128
		BCF CCP1CON,5
		BCF CCP1CON,4
		CLRF	AccLH
		CLRF	AccHH	; CLEAR High Freq Generator accumulator
		CLRF	AccLL
		CLRF	AccHL	; CLEAR Low Freq Generator accumulator
		ENABLE_IRQ
		
		; 100 ms pause
		;DISABLE_IRQ
		MOVLW	208
		MOVWF	TIME0
		MOVLW	3
		MOVWF	TIME1
		BCF	TIMEOUT	; start 200ms delay
		;ENABLE_IRQ
DTMF_digit4:
		BTFSS	TIMEOUT
		GOTO DTMF_digit4	; wait for TIMEOUT=1
		RETURN
comma
		; 500 ms pause
		;DISABLE_IRQ
		MOVLW	18
		MOVWF	TIME0
		MOVLW	19
		MOVWF	TIME1
		BCF	TIMEOUT	; start 500ms delay
		;ENABLE_IRQ
DTMF_digit5:
		BTFSS	TIMEOUT
		GOTO DTMF_digit5	; wait for TIMEOUT=1
		RETURN		


;************************************************************************
; send the string located at (XcomB:XcomC) in program memory to DTMF generator
DTMF_rom:
		; set dtmf on
		Bank2                                          
		movf   XcomC, W          ;Write the              
		movwf  EEADR            ;address bytes              
		movf   XcomB, W                        
		movwf  EEADRH
                           
		bsf    STATUS, RP0	;Bank3                       
		bsf    EECON1, EEPGD	;Point to program memory                       
		bsf    EECON1, RD       ;start read operation               
		nop                     ;required two nop's            
		nop                                  
		bcf    STATUS, RP0	;Bank2                       
		movf   EEDATA, W	;char in W                         
		andlw  0xFF		;compare 0                          
		btfsc  STATUS, Z                       
		goto   DTMF_rom2                          
		Bank0
		; DTMF char in W
		call  DTMF_digit	; send char in w to DTMF generator                        	            
		incfsz XcomC, F                          
		goto   DTMF_rom                         
		incf   XcomB, F                          
		goto   DTMF_rom                          
DTMF_rom2:
		Bank0
		; set PWM to 128

		return                  
;************************************************************************
ser_ram: 	;send from RAM to SERIAL buffer, string located at (IRP:W)
		movwf FSR
ser_ram1:	movlw 0
		subwf INDF, w		; compare 0
		btfsc STATUS, Z
		return			; char = zero
		movf INDF, W
		CALL TX_ADD_BUFFER	
		incf FSR, F
		goto ser_ram1 

;************************************************************************
; send the string located at (XcomB:XcomA) in program memory to serial buffer
ser_rom:
		Bank2                                          
		movf   XcomA, W          ;Write the              
		movwf  EEADR            ;address bytes              
		movf   XcomB, W                        
		movwf  EEADRH
                           
		bsf    STATUS, RP0	;Bank3                       
		bsf    EECON1, EEPGD	;Point to program memory                       
		bsf    EECON1, RD       ;start read operation               
		nop                     ;required two nop's            
		nop                                  
		bcf    STATUS, RP0	;Bank2                       
		movf   EEDATA, W	;char in W                         
		andlw  0xFF		;compare 0                          
		btfsc  STATUS, Z                       
		goto   ser_rom2                          
		Bank0
		call  TX_ADD_BUFFER	; print char in w                         	            
		incfsz XcomA, F                          
		goto   ser_rom                         
		incf   XcomB, F                          
		goto   ser_rom                          
ser_rom2:
		Bank0
		movlw	CR
		call 	TX_ADD_BUFFER
		movlw	LF
		call	TX_ADD_BUFFER
		return                  

; ***********************************************************************
;
;  INIT_UART - Initialises UART
;  enables recevier and transmitter
;  Make sure to be at bank0

INIT_UART
	; make sure pins are setup before calling this routine
	; TRISC:6 and TRISC:7 must be set ( as for output, but operates as input/output  -RB2 and RB5 for 16F88)
	; furthermore its advised that interrupts are disabled during this routine
	
	; setup baudrate
	MOVLW	SPBRG 	; get adress for serial baud reg
	MOVWF	FSR	; setup fsr
	MOVLW	CALC_HIGH_BAUD(9600) ; calculate baudrate is this example 9600 with brgh=1
	MOVWF	INDF	; and store it

	; enable transmitter
	MOVLW	TXSTA	; get adress for serial enable reg
	MOVWF	FSR	; setup fsr
	MOVLW	(1<<TXEN)|(1<<BRGH); preset enable transmitter and high speed mode
	MOVWF	INDF	; and set it

	; enable recevier
	MOVLW	(1<<SPEN)|(1<<CREN) ; preset serial port enable and continous recevie
	MOVWF	RCSTA	; set it

	; enable reciever interrupt
	MOVLW	PIE1	; get adress for periphial irq's
	MOVWF	FSR	; setup fsr
	BSF	INDF,RCIE ; enable reciever irq
	BSF	INTCON,PEIE ; and periphial irq must also be enabled

	RETURN

; ***********************************************************************
;
;  INIT_BUFFERS - Initialises all buffers and pointers
;  Make sure to be at bank0

INIT_BUFFERS

	; setup receive buffer
	CLRF	RX_Buffer_Count ; clear counter
	MOVLW	RX_Buffer	; get base adress for buffer
	MOVWF	RX_Buffer_InPtr ; save as in adress
	MOVWF	RX_Buffer_OutPtr; and out adress
	; setup transmit buffer
	CLRF	TX_Buffer_Count ; clear counter
	MOVLW	TX_Buffer	; get base adress for buffer
	MOVWF	TX_Buffer_InPtr ; save as in adress
	MOVWF	TX_Buffer_OutPtr; and out adress
	BCF	GOT_ONE		; no char in RxBuffer

	RETURN

; ***********************************************************************
;
;  TX_ADD_BUFFER - Puts one byte in serial tx buffer,  blocks until room available
;  Make sure to be at bank0 ( buffer pointers in bank0, buffers in bank1 )
;
; To be discussed - wait or return Z and discard

TX_ADD_BUFFER
	MOVWF	TX_Temp	; store byte temporarily
TX_ADD_TST	
	MOVF	TX_Buffer_Count,W ; get count
	XORLW	TX_BUFFER_SIZE  
	BTFSC	STATUS,Z	; test if any room
	GOTO	TX_ADD_TST	; nope no room, wait until there is
	
	MOVF	TX_Buffer_InPtr,W	; get adress to store byte
	MOVWF	FSR		; setup fsr
	MOVF	TX_Temp,W	; get byte
	MOVWF	INDF		; and store it

	; update buffer pointers
	INC_BUFFER	TX_Buffer_InPtr,TX_Buffer,TX_BUFFER_SIZE

	INCF	TX_Buffer_Count,F ; increment byte count
				; MUST not be GOT_ONEs until after byte is stored in buffer
				; and pointers updated
	
	MOVLW	PIE1	; get adress for periphial irq
	MOVWF	FSR	; setup fsr
	BSF	INDF,TXIE; and enable tx irq

	RETURN

; ***********************************************************************
;
;  RX_GET_BUFFER - Gets one byte from in serial rx buffer, if available
;
;	Return Z is no data is available, GOT_ONE reset

RX_GET_BUFFER
	MOVF	RX_Buffer_Count,F ; check if anything available ?
	BTFSC	STATUS,Z	;
	RETURN	; nope, nothing there, NOTE zero flag set !
	
	MOVF	FSR,W
	MOVWF	FSRSAVE
	; get pointer
	MOVF	RX_Buffer_OutPtr,W
	MOVWF	FSR	; setup FSR
	
	; update buffer pointers
	INC_BUFFER	RX_Buffer_OutPtr,RX_Buffer,RX_BUFFER_SIZE
	
	; get byte to W
	MOVF	INDF,W	
	MOVWF	Temp
	MOVF	FSRSAVE,W
	MOVWF	FSR
	MOVF	Temp,W
	; decrement counter
	DECF	RX_Buffer_Count,F 
	BTFSC	STATUS,Z	;
	BCF	GOT_ONE		; nope, nothing there, NOTE zero flag set, GOT_ONE reset
	
	BCF	STATUS,Z	; make sure zero flag is clear

	RETURN
;************************************************************************
;EEprom routines by Tony Kubek
; ***********************************************************************
; EE_WRITE_BYTE - Routine to write a byte to ee ram 
; Adress in W, byte MUST be in EE_Byte

EE_WRITE_BYTE
	Bank2			; select bank2
	MOVWF	EEADR		; setup adress
	Bank0			; 
	MOVF	EE_Byte,W	; get byte
	Bank2
	MOVWF	EEDATA		; setup byte to write
	BSF	STATUS,RP0	; bank3 !!
	BCF	EECON1,EEPGD	; set to data ee ram
	BSF	EECON1,WREN	; enable writes
	DISABLE_IRQ		; disable irq's
	
	MOVLW	H'55'		; required sequence !!
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR	; begin write procedure
	
	ENABLE_IRQ		; enable irq's again
	
	BCF	EECON1,WREN	; disable writes ( does not affect current write cycle )
	
	Bank0			; reset to bank0
	; wait for the write to complete before we return
	BTFSS  PIR2,EEIF	; wait for interrupt flag to be set
	GOTO   $-1		 
	; clear interupt bit and write enable bit
	BCF    PIR2,EEIF	;clear eewrite irq flag
	RETURN

; ***********************************************************************
; EE_READ_BYTE - Routine to read a byte from ee ram 
; Adress in W, byte will be delivered in W
EE_READ_BYTE
	Bank2
	MOVWF	EEADR		; put in adress reg.
	BSF	STATUS,RP0	; bank3 !!
	BCF	EECON1,EEPGD	; set to read data memory
	BSF	EECON1,RD	; set bit to read
	BCF	STATUS,RP0	; bank2 !!
	MOVF	EEDATA,W	; move data to W
	Bank0			; Reset to BANK0 !
	RETURN			; and return
;***************************************************************************

;***************************************************************************
; test strings

linie1:		DE 10,13,"ClearView007 (c) 2004 Radu Constantinescu",10,13,0
linie2:		DE "1234567890*#ABCD,,+++",0
linie3:		DE "",0
linie4:		DE "",0




      
	END
